{      WRITELOG.TPU    (c) 1995 CSC Ltd.  All right reserved.          }
{ ----============================================================---- }
{ Part: Procedure FormatString(S:String):String                        }
{                                                                      }

Function FormatString(S:String):String;
var
      W1,W2,W3,W4   : Word;
      C1,C2,C3,C4   : Char;
      CB1           : Byte absolute C1;
      CB2           : Byte absolute C2;
      CB3           : Byte absolute C3;
      CB4           : Byte absolute C4;
      Command       : String[10];
      SL            : Byte absolute S;
      S2,S3,S4,S5,S6: String;
      I, J, K       : Byte;
      ModeLast      : ModeType;

  begin
    With Modes[0] do begin
    S2:='';
    S5:='';
    For I:=1 to SL do
      begin
        C1:=S[I];
        if C1='%' then
          begin
            C2:=UpCase(S[I+1]);
            Case C2 of
              '%'       : Begin
                            S5:=S5+C2;
                            Inc(I);
                          end;
              end; {of CASE}
          end; {of IF}
      end;
    For i:=1 to SL do
      begin
        C1:=S[I];
        if C1='%' then
          begin
            C2:=UpCase(S[I+1]);
            Case C2 of
              '%'       : Begin
                            S2:=S2+C2;
                            Inc(I);
                          end;
              '$'       : Begin
                            S3:=S[I+2]+S[I+3];
                            S2:=S2+Chr(Hex2Byte(S3));
                            I:=I+3;
                          end;
              'B'       : Begin
                            C3:=UpCase(S[I+2]);
                            J:=0;
                            Case C3 of
                              '0'..'9' : J:=CB3-48;
                              'A'..'Z' : J:=CB3-55;
                            end;
                            S2:=S2+LoadIntValue(J,0);
                            I:=I+2;
                          end;
              'C'       : Begin
                            C3:=UpCase(S[I+2]);
                            C4:=S[I+3];
                            Case C3 of
                              'D'  : DateDivideChar:=C4;
                              'N'  : DateNumDivideChar:=C4;
                              'T'  : TimeDivideChar:=C4;
                            end;
                            I:=I+3;
                          end;
              'D'       : Begin
                            C3:=UpCase(S[I+2]);
                            GetDate(W1,W2,W3,W4);
                            Case C3 of
                              'T'  : S2:=S2+FormatDate(W1,W2,W3,W4);
                              'D'  : S2:=S2+DayFormat(W3);
                              'M'  : S2:=S2+MonthFormat(W2);
                              'Y'  : S2:=S2+YearFormat(W1);
                              'W'  : S2:=S2+WeekDayFormat(W4);
                              '0'  : DateMode:=0;
                              '1'  : DateMode:=1;
                              '2'  : YearMode:=False;
                              '3'  : YearMode:=True;
                              '4'  : MonthMode:=0;
                              '5'  : MonthMode:=1;
                              '6'  : MonthMode:=2;
                              '7'  : MonthMode:=3;
                              '8'  : WeekDayMode:=False;
                              '9'  : WeekDayMode:=True;
                            end;
                            I:=I+2;
                          end;
              'H'       : Begin
                            C3:=UpCase(S[I+2]);
                            J:=0;
                            Case C3 of
                              '0'..'9' : J:=CB3-48;
                              'A'..'Z' : J:=CB3-55;
                            end;
                            S2:=S2+LoadIntValue(J,2);
                            I:=I+2;
                          end;
              'L'       : Begin
                            C3:=UpCase(S[I+2]);
                            S3:='';
                            Case C3 of
                              'F'  : S3:=#10;
                              'N'  : S3:=#13#10;
                              'S'  : S3:=#13;
                              'T'  : S3:=#9;
                            end;
                            S2:=S2+S3;
                            I:=I+2;
                          end;
              'M'       : Begin
                            C3:=UpCase(S[I+2]);
                            C4:=UpCase(S[I+3]);
                            Case C3 of
                              'B'  : Begin
                                       Case C4 of
                                         '0'..'9','A'..'F':
                                           Begin
                                             W1:=Hex2Byte(C4);
                                             if W1=0 then W1:=16;
                                             LenByteDefault:=W1;
                                           end;
                                         end;
                                       Inc(I);
                                     end;
                              'H'  : Begin
                                       Case C4 of
                                         '0'..'9','A'..'F':
                                             HexMode:=Hex2Byte(C4);
                                         end;
                                       Inc(I);
                                     end;
                              'L'  : Begin
                                       Case C4 of
                                         '0'..'9','A'..'F':
                                           Begin
                                             W1:=Hex2Byte(C4);
                                             if W1=0 then W1:=16;
                                             HexLenDefault:=W1;
                                           end;
                                         end;
                                       Inc(I);
                                     end;
                              'S'  : Begin
                                       Case C4 of
                                         '0' : UpCaseMode:=0;
                                         '1' : UpCaseMode:=1;
                                         '2' : UpCaseMode:=2;
                                         '3' : RussianUpCase:=False;
                                         '4' : RussianUpCase:=True;
                                         end;
                                       Inc(I);
                                     end;
                              'Z'  : Begin
                                       Case C4 of
                                         '0'..'9','A'..'F':
                                           Begin
                                             W1:=Hex2Byte(C4);
                                             if W1=0 then W1:=16;
                                             LeadZeroDefault:=W1;
                                           end;
                                         end;
                                       Inc(I);
                                     end;
                            end;
                            I:=I+2;
                          end;
              'R'       : Begin
                            C3:=UpCase(S[I+2]);
                            J:=0;
                            Case C3 of
                              '0'..'9' : J:=CB3-48;
                              'A'..'Z' : J:=CB3-55;
                            end;
                            S2:=S2+StrValues[J];
                            I:=I+2;
                          end;
              'S'       : Begin
                            C3:=UpCase(S[I+2]);
                            Case C3 of
                              'S'  : Modes[1]:=Modes[0];
                              'L'  : Modes[0]:=Modes[1];
                              'E'  : Begin
                                       ModeLast:=Modes[0];
                                       Modes[0]:=Modes[1];
                                       Modes[1]:=ModeLast;
                                     end;
                              'N'  : Modes:=ModeData;
                            end;
                            I:=I+2;
                          end;
              'T'       : Begin
                            C3:=UpCase(S[I+2]);
                            GetTime(W1,W2,W3,W4);
                            Case C3 of
                              'D'  : Begin
                                       GetDate(W1,W2,W3,W4);
                                       S2:=S2+FormatDate(W1,W2,W3,W4);
                                       GetTime(W1,W2,W3,W4);
                                       S2:=S2+', '+FormatTime(W1,W2,W3);
                                     end;
                              'T'  : S2:=S2+FormatTime(W1,W2,W3);
                              'H'  : S2:=S2+HourFormat(W1);
                              'M'  : S2:=S2+MinFormat(W2);
                              'S'  : S2:=S2+SecFormat(W3);
                              '0'  : TimeMode:=0;
                              '1'  : TimeMode:=1;
                              '2'  : TimeMode:=2;
                              '3'  : TimeFormMode:=False;
                              '4'  : TimeFormMode:=True;
                            end;
                            I:=I+2;
                          end;
              'Z'       : Begin
                            C3:=UpCase(S[I+2]);
                            J:=0;
                            Case C3 of
                              '0'..'9' : J:=CB3-48;
                              'A'..'Z' : J:=CB3-55;
                            end;
                            S2:=S2+LoadIntValue(J,1);
                            I:=I+2;
                          end
               else
                 begin    { ᫨ H p }
                   S2:=S2+C1;
                 end;
            end;
          end
          else S2:=S2+C1;
      end;
    FormatString:=S2;
    end;
  end;

